package dev.peerat.mapping.providers;

import java.io.File;

import dev.peerat.mapping.Ship;
import dev.peerat.parser.java.Class;
import dev.peerat.parser.java.Function;
import dev.peerat.parser.java.JavaElement;
import dev.peerat.parser.java.value.InstanceValue;
import dev.peerat.parser.java.value.MethodCallValue;

public interface Provider{
	
	void init(File file) throws Exception;
	
	void mapTreasure(Class clazz);
	
	void mapBottle(Class clazz, Function function);

	void mapCreation(Class clazz, JavaElement container,  InstanceValue value);
	void mapEdit(Class clazz, JavaElement container, MethodCallValue value);
	
	void complete();
	
	void register(Ship ship) throws Exception;
}
